// This file is auto-generated by @hey-api/openapi-ts

import {
  type Options as ClientOptions,
  type TDataShape,
  type Client,
  formDataBodySerializer,
} from "@hey-api/client-axios";
import type {
  AuthKickstartLoginData,
  AuthKickstartLoginError,
  AuthLoginCallbackData,
  AuthLoginCallbackError,
  AuthKickstartAccountConnectionData,
  AuthKickstartAccountConnectionError,
  AuthAccountConnectionCallbackData,
  AuthAccountConnectionCallbackError,
  AuthLogoutData,
  ApiTokenListTokenData,
  ApiTokenListTokenResponse,
  ApiTokenListTokenError,
  ApiTokenCreateTokenData,
  ApiTokenCreateTokenResponse,
  ApiTokenCreateTokenError,
  ApiTokenDeleteTokenData,
  ApiTokenDeleteTokenResponse,
  ApiTokenDeleteTokenError,
  ApiTokenGetTokenData,
  ApiTokenGetTokenResponse,
  ApiTokenGetTokenError,
  UserListUsersData,
  UserListUsersResponse,
  UserListUsersError,
  UserCreateUserData,
  UserCreateUserResponse,
  UserCreateUserError,
  UserSearchUsersData,
  UserSearchUsersResponse,
  UserSearchUsersError,
  UserGetLoggedInUserData,
  UserGetLoggedInUserResponse,
  UserDeleteUserData,
  UserDeleteUserResponse,
  UserDeleteUserError,
  UserGetUserData,
  UserGetUserResponse,
  UserGetUserError,
  UserUpdateRolesData,
  UserUpdateRolesResponse,
  UserUpdateRolesError,
  UserResendInvitationData,
  UserResendInvitationResponse,
  UserResendInvitationError,
  S3KeyGetUserKeysData,
  S3KeyGetUserKeysResponse,
  S3KeyGetUserKeysError,
  S3KeyCreateUserKeyData,
  S3KeyCreateUserKeyResponse,
  S3KeyCreateUserKeyError,
  S3KeyDeleteUserKeyData,
  S3KeyDeleteUserKeyResponse,
  S3KeyDeleteUserKeyError,
  S3KeyGetUserKeyData,
  S3KeyGetUserKeyResponse,
  S3KeyGetUserKeyError,
  BucketListBucketsData,
  BucketListBucketsResponse,
  BucketListBucketsError,
  BucketCreateBucketData,
  BucketCreateBucketResponse,
  BucketCreateBucketError,
  BucketListBucketOtrsData,
  BucketListBucketOtrsResponse,
  BucketListBucketOtrsError,
  BucketDeleteBucketData,
  BucketDeleteBucketResponse,
  BucketDeleteBucketError,
  BucketGetBucketData,
  BucketGetBucketResponse,
  BucketGetBucketError,
  BucketDeleteBucketOtrData,
  BucketDeleteBucketOtrResponse,
  BucketDeleteBucketOtrError,
  BucketGetBucketOtrData,
  BucketGetBucketOtrResponse,
  BucketGetBucketOtrError,
  BucketAcceptBucketOtrData,
  BucketAcceptBucketOtrResponse,
  BucketAcceptBucketOtrError,
  BucketCreateBucketOtrData,
  BucketCreateBucketOtrResponse,
  BucketCreateBucketOtrError,
  BucketUpdateBucketPublicStateData,
  BucketUpdateBucketPublicStateResponse,
  BucketUpdateBucketPublicStateError,
  BucketUpdateBucketLimitsData,
  BucketUpdateBucketLimitsResponse,
  BucketUpdateBucketLimitsError,
  BucketPermissionListPermissionsData,
  BucketPermissionListPermissionsResponse,
  BucketPermissionListPermissionsError,
  BucketPermissionCreatePermissionData,
  BucketPermissionCreatePermissionResponse,
  BucketPermissionCreatePermissionError,
  BucketPermissionListPermissionsPerUserData,
  BucketPermissionListPermissionsPerUserResponse,
  BucketPermissionListPermissionsPerUserError,
  BucketPermissionListPermissionsPerBucketData,
  BucketPermissionListPermissionsPerBucketResponse,
  BucketPermissionListPermissionsPerBucketError,
  BucketPermissionDeletePermissionData,
  BucketPermissionDeletePermissionResponse,
  BucketPermissionDeletePermissionError,
  BucketPermissionGetPermissionData,
  BucketPermissionGetPermissionResponse,
  BucketPermissionGetPermissionError,
  BucketPermissionUpdatePermissionData,
  BucketPermissionUpdatePermissionResponse,
  BucketPermissionUpdatePermissionError,
  WorkflowListWorkflowsData,
  WorkflowListWorkflowsResponse,
  WorkflowListWorkflowsError,
  WorkflowCreateWorkflowData,
  WorkflowCreateWorkflowResponse,
  WorkflowCreateWorkflowError,
  WorkflowListWorkflowOtrsData,
  WorkflowListWorkflowOtrsResponse,
  WorkflowListWorkflowOtrsError,
  WorkflowGetDeveloperWorkflowStatisticsData,
  WorkflowGetDeveloperWorkflowStatisticsResponse,
  WorkflowGetDeveloperWorkflowStatisticsError,
  WorkflowDeleteWorkflowData,
  WorkflowDeleteWorkflowResponse,
  WorkflowDeleteWorkflowError,
  WorkflowGetWorkflowData,
  WorkflowGetWorkflowResponse,
  WorkflowGetWorkflowError,
  WorkflowDeleteWorkflowOtrData,
  WorkflowDeleteWorkflowOtrResponse,
  WorkflowDeleteWorkflowOtrError,
  WorkflowGetWorkflowOtrData,
  WorkflowGetWorkflowOtrResponse,
  WorkflowGetWorkflowOtrError,
  WorkflowAcceptWorkflowOtrData,
  WorkflowAcceptWorkflowOtrResponse,
  WorkflowAcceptWorkflowOtrError,
  WorkflowCreateWorkflowOtrData,
  WorkflowCreateWorkflowOtrResponse,
  WorkflowCreateWorkflowOtrError,
  WorkflowGetWorkflowStatisticsData,
  WorkflowGetWorkflowStatisticsResponse,
  WorkflowGetWorkflowStatisticsError,
  WorkflowUpdateWorkflowData,
  WorkflowUpdateWorkflowResponse,
  WorkflowUpdateWorkflowError,
  WorkflowVersionListWorkflowVersionData,
  WorkflowVersionListWorkflowVersionResponse,
  WorkflowVersionListWorkflowVersionError,
  WorkflowVersionGetWorkflowVersionData,
  WorkflowVersionGetWorkflowVersionResponse,
  WorkflowVersionGetWorkflowVersionError,
  WorkflowVersionUpdateWorkflowVersionStatusData,
  WorkflowVersionUpdateWorkflowVersionStatusResponse,
  WorkflowVersionUpdateWorkflowVersionStatusError,
  WorkflowVersionGetWorkflowVersionMetadataData,
  WorkflowVersionGetWorkflowVersionMetadataResponse,
  WorkflowVersionGetWorkflowVersionMetadataError,
  WorkflowVersionUpdateWorkflowVersionMetadataData,
  WorkflowVersionUpdateWorkflowVersionMetadataResponse,
  WorkflowVersionUpdateWorkflowVersionMetadataError,
  WorkflowVersionDeprecateWorkflowVersionData,
  WorkflowVersionDeprecateWorkflowVersionResponse,
  WorkflowVersionDeprecateWorkflowVersionError,
  WorkflowVersionUpdateWorkflowVersionParameterExtensionData,
  WorkflowVersionUpdateWorkflowVersionParameterExtensionResponse,
  WorkflowVersionUpdateWorkflowVersionParameterExtensionError,
  WorkflowVersionDownloadWorkflowDocumentationData,
  WorkflowVersionDownloadWorkflowDocumentationError,
  WorkflowVersionDeleteWorkflowVersionIconData,
  WorkflowVersionDeleteWorkflowVersionIconResponse,
  WorkflowVersionDeleteWorkflowVersionIconError,
  WorkflowVersionUploadWorkflowVersionIconData,
  WorkflowVersionUploadWorkflowVersionIconResponse,
  WorkflowVersionUploadWorkflowVersionIconError,
  WorkflowExecutionListWorkflowExecutionsData,
  WorkflowExecutionListWorkflowExecutionsResponse,
  WorkflowExecutionListWorkflowExecutionsError,
  WorkflowExecutionStartWorkflowData,
  WorkflowExecutionStartWorkflowResponse,
  WorkflowExecutionStartWorkflowError,
  WorkflowExecutionStartArbitraryWorkflowData,
  WorkflowExecutionStartArbitraryWorkflowResponse,
  WorkflowExecutionStartArbitraryWorkflowError,
  WorkflowExecutionDeleteWorkflowExecutionData,
  WorkflowExecutionDeleteWorkflowExecutionResponse,
  WorkflowExecutionDeleteWorkflowExecutionError,
  WorkflowExecutionGetWorkflowExecutionData,
  WorkflowExecutionGetWorkflowExecutionResponse,
  WorkflowExecutionGetWorkflowExecutionError,
  WorkflowExecutionGetWorkflowExecutionParamsData,
  WorkflowExecutionGetWorkflowExecutionParamsResponse,
  WorkflowExecutionGetWorkflowExecutionParamsError,
  WorkflowExecutionCancelWorkflowExecutionData,
  WorkflowExecutionCancelWorkflowExecutionResponse,
  WorkflowExecutionCancelWorkflowExecutionError,
  WorkflowCredentialsDeleteWorkflowCredentialsData,
  WorkflowCredentialsDeleteWorkflowCredentialsResponse,
  WorkflowCredentialsDeleteWorkflowCredentialsError,
  WorkflowCredentialsGetWorkflowCredentialsData,
  WorkflowCredentialsGetWorkflowCredentialsResponse,
  WorkflowCredentialsGetWorkflowCredentialsError,
  WorkflowCredentialsUpdateWorkflowCredentialsData,
  WorkflowCredentialsUpdateWorkflowCredentialsError,
  WorkflowModeGetWorkflowModeData,
  WorkflowModeGetWorkflowModeResponse,
  WorkflowModeGetWorkflowModeError,
  ResourceListResourcesData,
  ResourceListResourcesResponse,
  ResourceListResourcesError,
  ResourceCreateResourceData,
  ResourceCreateResourceResponse,
  ResourceCreateResourceError,
  ResourceListSyncRequestsData,
  ResourceListSyncRequestsResponse,
  ResourceListResourceOtrsData,
  ResourceListResourceOtrsResponse,
  ResourceListResourceOtrsError,
  ResourceDeleteResourceData,
  ResourceDeleteResourceResponse,
  ResourceDeleteResourceError,
  ResourceGetResourceData,
  ResourceGetResourceResponse,
  ResourceGetResourceError,
  ResourceDeleteResourceOtrData,
  ResourceDeleteResourceOtrResponse,
  ResourceDeleteResourceOtrError,
  ResourceGetResourceOtrData,
  ResourceGetResourceOtrResponse,
  ResourceGetResourceOtrError,
  ResourceAcceptResourceOtrData,
  ResourceAcceptResourceOtrResponse,
  ResourceAcceptResourceOtrError,
  ResourceCreateResourceOtrData,
  ResourceCreateResourceOtrResponse,
  ResourceCreateResourceOtrError,
  ResourceVersionListResourceVersionsData,
  ResourceVersionListResourceVersionsResponse,
  ResourceVersionListResourceVersionsError,
  ResourceVersionRequestResourceVersionData,
  ResourceVersionRequestResourceVersionResponse,
  ResourceVersionRequestResourceVersionError,
  ResourceVersionGetResourceVersionData,
  ResourceVersionGetResourceVersionResponse,
  ResourceVersionGetResourceVersionError,
  ResourceVersionResourceFileTreeData,
  ResourceVersionResourceFileTreeResponse,
  ResourceVersionResourceFileTreeError,
  ResourceVersionRequestResourceVersionReviewData,
  ResourceVersionRequestResourceVersionReviewResponse,
  ResourceVersionRequestResourceVersionReviewError,
  ResourceVersionRequestResourceVersionSyncData,
  ResourceVersionRequestResourceVersionSyncResponse,
  ResourceVersionRequestResourceVersionSyncError,
  ResourceVersionResourceVersionReviewData,
  ResourceVersionResourceVersionReviewResponse,
  ResourceVersionResourceVersionReviewError,
  ResourceVersionResourceVersionSyncData,
  ResourceVersionResourceVersionSyncResponse,
  ResourceVersionResourceVersionSyncError,
  ResourceVersionResourceVersionLatestData,
  ResourceVersionResourceVersionLatestResponse,
  ResourceVersionResourceVersionLatestError,
  ResourceVersionDeleteResourceVersionClusterData,
  ResourceVersionDeleteResourceVersionClusterResponse,
  ResourceVersionDeleteResourceVersionClusterError,
  ResourceVersionDeleteResourceVersionS3Data,
  ResourceVersionDeleteResourceVersionS3Response,
  ResourceVersionDeleteResourceVersionS3Error,
  NewsListNewsData,
  NewsListNewsResponse,
  NewsListNewsError,
  NewsCreateNewsData,
  NewsCreateNewsResponse,
  NewsCreateNewsError,
  NewsListLatestNewsData,
  NewsListLatestNewsResponse,
  NewsDeleteNewsData,
  NewsDeleteNewsResponse,
  NewsDeleteNewsError,
  NewsGetNewsData,
  NewsGetNewsResponse,
  NewsGetNewsError,
  PublicGetPublicWorkflowsData,
  PublicGetPublicWorkflowsResponse,
} from "./types.gen";
import { client as _heyApiClient } from "./client.gen";
import { resourceVersionResourceFileTreeResponseTransformer } from "./transformers.gen";

export type Options<
  TData extends TDataShape = TDataShape,
  ThrowOnError extends boolean = boolean,
> = ClientOptions<TData, ThrowOnError> & {
  /**
   * You can provide a client instance returned by `createClient()` instead of
   * individual options. This might be also useful if you want to implement a
   * custom client.
   */
  client?: Client;
  /**
   * You can pass arbitrary values through the `meta` object. This can be
   * used to access values that aren't defined as part of the SDK function.
   */
  meta?: Record<string, unknown>;
};

export class AuthService {
  /**
   * Kickstart the login flow
   * Redirect route to OIDC provider to kickstart the login process.
   */
  public static authKickstartLogin<ThrowOnError extends boolean = true>(
    options: Options<AuthKickstartLoginData, ThrowOnError>,
  ) {
    return (options.client ?? _heyApiClient).get<
      unknown,
      AuthKickstartLoginError,
      ThrowOnError
    >({
      url: "/auth/login/{provider}",
      ...options,
    });
  }

  /**
   * LifeScience Login Callback
   * Callback for the login process with an OIDC Provider.
   *
   * Visit the route login route to start the login process.
   *
   * If the user is already known to the system, then a JWT token will be created and sent via the 'set-cookie' header.
   * The key for this Cookie is 'bearer'.
   *
   * If the user is new, he will be created him and then a JWT token is issued.
   *
   * This JWT has to be sent to all authorized endpoints via the HTTPBearer scheme.
   */
  public static authLoginCallback<ThrowOnError extends boolean = true>(
    options: Options<AuthLoginCallbackData, ThrowOnError>,
  ) {
    return (options.client ?? _heyApiClient).get<
      unknown,
      AuthLoginCallbackError,
      ThrowOnError
    >({
      url: "/auth/login/callback/{provider}",
      ...options,
    });
  }

  /**
   * Kickstart the account connection flow
   * Redirect route to OIDC provider to connect the CloWM account with the AAI account.
   */
  public static authKickstartAccountConnection<
    ThrowOnError extends boolean = true,
  >(options: Options<AuthKickstartAccountConnectionData, ThrowOnError>) {
    return (options.client ?? _heyApiClient).get<
      unknown,
      AuthKickstartAccountConnectionError,
      ThrowOnError
    >({
      url: "/auth/account/connect/{provider}",
      ...options,
    });
  }

  /**
   * LifeScience Login Callback
   * Callback for the account connection process with an OIDC provider.
   */
  public static authAccountConnectionCallback<
    ThrowOnError extends boolean = true,
  >(options: Options<AuthAccountConnectionCallbackData, ThrowOnError>) {
    return (options.client ?? _heyApiClient).get<
      unknown,
      AuthAccountConnectionCallbackError,
      ThrowOnError
    >({
      url: "/auth/account/callback/{provider}",
      ...options,
    });
  }

  /**
   * Logout
   * Logout the user from the system by deleting the bearer cookie.
   */
  public static authLogout<ThrowOnError extends boolean = true>(
    options?: Options<AuthLogoutData, ThrowOnError>,
  ) {
    return (options?.client ?? _heyApiClient).get<
      unknown,
      unknown,
      ThrowOnError
    >({
      url: "/auth/logout",
      ...options,
    });
  }
}

export class ApiTokenService {
  /**
   * List API token
   * List meta information about all API token.
   *
   * Permissions `api_token:list_all` required. See parameter `uid` for exception.
   */
  public static apiTokenListToken<ThrowOnError extends boolean = true>(
    options?: Options<ApiTokenListTokenData, ThrowOnError>,
  ) {
    return (options?.client ?? _heyApiClient).get<
      ApiTokenListTokenResponse,
      ApiTokenListTokenError,
      ThrowOnError
    >({
      url: "/ui/tokens",
      ...options,
    });
  }

  /**
   * Create new API token
   * Create a new API token for the current user.
   *
   * Permission `api_token:create` required.
   */
  public static apiTokenCreateToken<ThrowOnError extends boolean = true>(
    options: Options<ApiTokenCreateTokenData, ThrowOnError>,
  ) {
    return (options.client ?? _heyApiClient).post<
      ApiTokenCreateTokenResponse,
      ApiTokenCreateTokenError,
      ThrowOnError
    >({
      url: "/ui/tokens",
      ...options,
      headers: {
        "Content-Type": "application/json",
        ...options?.headers,
      },
    });
  }

  /**
   * Delete API token
   * Delete an API token by id.
   *
   * Permission `api_token:delete` required if the current user is the owner of the API token,
   * otherwise `api_token:delete_any` required.
   */
  public static apiTokenDeleteToken<ThrowOnError extends boolean = true>(
    options: Options<ApiTokenDeleteTokenData, ThrowOnError>,
  ) {
    return (options.client ?? _heyApiClient).delete<
      ApiTokenDeleteTokenResponse,
      ApiTokenDeleteTokenError,
      ThrowOnError
    >({
      url: "/ui/tokens/{tid}",
      ...options,
    });
  }

  /**
   * Get API token
   * Get an API token by id.
   *
   * Permission `api_token:read` required if the current user is the owner of the API token,
   * otherwise `api_token:read_any` required.
   */
  public static apiTokenGetToken<ThrowOnError extends boolean = true>(
    options: Options<ApiTokenGetTokenData, ThrowOnError>,
  ) {
    return (options.client ?? _heyApiClient).get<
      ApiTokenGetTokenResponse,
      ApiTokenGetTokenError,
      ThrowOnError
    >({
      url: "/ui/tokens/{tid}",
      ...options,
    });
  }
}

export class UserService {
  /**
   * List users and search by their name
   * List all users in the system..
   *
   * Permission `user:list` required.
   */
  public static userListUsers<ThrowOnError extends boolean = true>(
    options?: Options<UserListUsersData, ThrowOnError>,
  ) {
    return (options?.client ?? _heyApiClient).get<
      UserListUsersResponse,
      UserListUsersError,
      ThrowOnError
    >({
      url: "/ui/users",
      ...options,
    });
  }

  /**
   * Create User
   * Create a new user in the system and notify him.
   *
   * Permission `user:create` required.
   */
  public static userCreateUser<ThrowOnError extends boolean = true>(
    options: Options<UserCreateUserData, ThrowOnError>,
  ) {
    return (options.client ?? _heyApiClient).post<
      UserCreateUserResponse,
      UserCreateUserError,
      ThrowOnError
    >({
      url: "/ui/users",
      ...options,
      headers: {
        "Content-Type": "application/json",
        ...options?.headers,
      },
    });
  }

  /**
   * Search Users
   * Search for users in the system by their name.
   *
   * Permission `user: search` required.
   */
  public static userSearchUsers<ThrowOnError extends boolean = true>(
    options: Options<UserSearchUsersData, ThrowOnError>,
  ) {
    return (options.client ?? _heyApiClient).get<
      UserSearchUsersResponse,
      UserSearchUsersError,
      ThrowOnError
    >({
      url: "/ui/users/search",
      ...options,
    });
  }

  /**
   * Get the logged in user
   * Return the user associated with the used JWT.
   *
   * Permission `user:read` required.
   */
  public static userGetLoggedInUser<ThrowOnError extends boolean = true>(
    options?: Options<UserGetLoggedInUserData, ThrowOnError>,
  ) {
    return (options?.client ?? _heyApiClient).get<
      UserGetLoggedInUserResponse,
      unknown,
      ThrowOnError
    >({
      url: "/ui/users/me",
      ...options,
    });
  }

  /**
   * Delete a user
   * Delete a user and his S3 account.
   *
   * Permission `user:delete` required if the current user is the target user.
   */
  public static userDeleteUser<ThrowOnError extends boolean = true>(
    options: Options<UserDeleteUserData, ThrowOnError>,
  ) {
    return (options.client ?? _heyApiClient).delete<
      UserDeleteUserResponse,
      UserDeleteUserError,
      ThrowOnError
    >({
      url: "/ui/users/{uid}",
      ...options,
    });
  }

  /**
   * Get a user by its uid
   * Return the user with the specific uid.
   *
   * Permission `user:read` required.
   */
  public static userGetUser<ThrowOnError extends boolean = true>(
    options: Options<UserGetUserData, ThrowOnError>,
  ) {
    return (options.client ?? _heyApiClient).get<
      UserGetUserResponse,
      UserGetUserError,
      ThrowOnError
    >({
      url: "/ui/users/{uid}",
      ...options,
    });
  }

  /**
   * Update user roles
   * Update the roles of a user.
   *
   * Permission `user:update` required.
   */
  public static userUpdateRoles<ThrowOnError extends boolean = true>(
    options: Options<UserUpdateRolesData, ThrowOnError>,
  ) {
    return (options.client ?? _heyApiClient).put<
      UserUpdateRolesResponse,
      UserUpdateRolesError,
      ThrowOnError
    >({
      url: "/ui/users/{uid}/roles",
      ...options,
      headers: {
        "Content-Type": "application/json",
        ...options?.headers,
      },
    });
  }

  /**
   * Resend Invitation
   * Resend the invitation link for an user that has an open invitation.
   *
   * Permission `user:create` required.
   */
  public static userResendInvitation<ThrowOnError extends boolean = true>(
    options: Options<UserResendInvitationData, ThrowOnError>,
  ) {
    return (options.client ?? _heyApiClient).patch<
      UserResendInvitationResponse,
      UserResendInvitationError,
      ThrowOnError
    >({
      url: "/ui/users/{uid}/invitation",
      ...options,
    });
  }
}

export class S3KeyService {
  /**
   * Get the S3 Access keys from a user
   * Get all the S3 Access keys for a specific user.
   *
   * Permission `s3_key:list` required if the current user is the target, otherwise `s3_key:list_all` required.
   */
  public static s3KeyGetUserKeys<ThrowOnError extends boolean = true>(
    options: Options<S3KeyGetUserKeysData, ThrowOnError>,
  ) {
    return (options.client ?? _heyApiClient).get<
      S3KeyGetUserKeysResponse,
      S3KeyGetUserKeysError,
      ThrowOnError
    >({
      url: "/ui/users/{uid}/keys",
      ...options,
    });
  }

  /**
   * Create a Access key for a user
   * Create a S3 Access key for a specific user.
   *
   * Permission `s3_key:create` required if the current user is the target, otherwise `s3_key:create_any` required.
   */
  public static s3KeyCreateUserKey<ThrowOnError extends boolean = true>(
    options: Options<S3KeyCreateUserKeyData, ThrowOnError>,
  ) {
    return (options.client ?? _heyApiClient).post<
      S3KeyCreateUserKeyResponse,
      S3KeyCreateUserKeyError,
      ThrowOnError
    >({
      url: "/ui/users/{uid}/keys",
      ...options,
    });
  }

  /**
   * Delete a specific S3 Access key from a user
   * Delete a specific S3 Access key for a specific user.
   *
   * Permission `s3_key:delete` required if the current user is the target, otherwise `s3_key:delete_any` required.
   */
  public static s3KeyDeleteUserKey<ThrowOnError extends boolean = true>(
    options: Options<S3KeyDeleteUserKeyData, ThrowOnError>,
  ) {
    return (options.client ?? _heyApiClient).delete<
      S3KeyDeleteUserKeyResponse,
      S3KeyDeleteUserKeyError,
      ThrowOnError
    >({
      url: "/ui/users/{uid}/keys/{access_id}",
      ...options,
    });
  }

  /**
   * Get a specific S3 Access key from a user
   * Get a specific S3 Access Key for a specific user.
   *
   * Permission `s3_key:read` required if the current user is the target, otherwise `s3_key:read_any` required.
   */
  public static s3KeyGetUserKey<ThrowOnError extends boolean = true>(
    options: Options<S3KeyGetUserKeyData, ThrowOnError>,
  ) {
    return (options.client ?? _heyApiClient).get<
      S3KeyGetUserKeyResponse,
      S3KeyGetUserKeyError,
      ThrowOnError
    >({
      url: "/ui/users/{uid}/keys/{access_id}",
      ...options,
    });
  }
}

export class BucketService {
  /**
   * List buckets
   * List all the buckets in the system or of the desired user where the user has permissions for.
   *
   * Permission `bucket:list_all` required. See parameter `owner_id` for exception.
   */
  public static bucketListBuckets<ThrowOnError extends boolean = true>(
    options?: Options<BucketListBucketsData, ThrowOnError>,
  ) {
    return (options?.client ?? _heyApiClient).get<
      BucketListBucketsResponse,
      BucketListBucketsError,
      ThrowOnError
    >({
      url: "/ui/buckets",
      ...options,
    });
  }

  /**
   * Create a bucket for the current user
   * Create a bucket for the current user.
   *
   * The name of the bucket has some constraints.
   * For more information see the
   * [Ceph documentation](https://docs.ceph.com/en/quincy/radosgw/s3/bucketops/#constraints)
   *
   * Permission `bucket:create` required.
   */
  public static bucketCreateBucket<ThrowOnError extends boolean = true>(
    options: Options<BucketCreateBucketData, ThrowOnError>,
  ) {
    return (options.client ?? _heyApiClient).post<
      BucketCreateBucketResponse,
      BucketCreateBucketError,
      ThrowOnError
    >({
      url: "/ui/buckets",
      ...options,
      headers: {
        "Content-Type": "application/json",
        ...options?.headers,
      },
    });
  }

  /**
   * List bucket OTRs
   * Get the ownership transfer requests for buckets.
   *
   * Permission `bucket:list` required if `current_owner_id` or `new_owner_id` is the current users id,
   * otherwise `bucket:list_all`
   */
  public static bucketListBucketOtrs<ThrowOnError extends boolean = true>(
    options?: Options<BucketListBucketOtrsData, ThrowOnError>,
  ) {
    return (options?.client ?? _heyApiClient).get<
      BucketListBucketOtrsResponse,
      BucketListBucketOtrsError,
      ThrowOnError
    >({
      url: "/ui/buckets/ownership_transfer_request",
      ...options,
    });
  }

  /**
   * Delete a bucket
   * Delete a bucket by its name. Only the owner of the bucket can delete the bucket.
   *
   * Permission `bucket:delete` required if the current user is the owner of the bucket,
   * otherwise `bucket:delete_any` required.
   */
  public static bucketDeleteBucket<ThrowOnError extends boolean = true>(
    options: Options<BucketDeleteBucketData, ThrowOnError>,
  ) {
    return (options.client ?? _heyApiClient).delete<
      BucketDeleteBucketResponse,
      BucketDeleteBucketError,
      ThrowOnError
    >({
      url: "/ui/buckets/{bucket_name}",
      ...options,
    });
  }

  /**
   * Get a bucket by its name
   * Get a bucket by its name if the current user has READ permissions for the bucket.
   *
   * Permission `bucket:read` required if the current user is the owner of the bucket,
   * otherwise `bucket:read_any` required.
   */
  public static bucketGetBucket<ThrowOnError extends boolean = true>(
    options: Options<BucketGetBucketData, ThrowOnError>,
  ) {
    return (options.client ?? _heyApiClient).get<
      BucketGetBucketResponse,
      BucketGetBucketError,
      ThrowOnError
    >({
      url: "/ui/buckets/{bucket_name}",
      ...options,
    });
  }

  /**
   * Delete a bucket OTR
   * Delete/Reject a bucket ownership transfer request.
   *
   * Permission `bucket:update` required if the current user is the current or new owner of the bucket,
   * otherwise `bucket:update_any` required.
   */
  public static bucketDeleteBucketOtr<ThrowOnError extends boolean = true>(
    options: Options<BucketDeleteBucketOtrData, ThrowOnError>,
  ) {
    return (options.client ?? _heyApiClient).delete<
      BucketDeleteBucketOtrResponse,
      BucketDeleteBucketOtrError,
      ThrowOnError
    >({
      url: "/ui/buckets/{bucket_name}/ownership_transfer_request",
      ...options,
    });
  }

  /**
   * Get a bucket OTR
   * Get a specific bucket ownership transfer request.
   *
   * Permission `bucket:read` required if the current user is the current or new owner of the bucket,
   * otherwise `bucket:read_any` required.
   */
  public static bucketGetBucketOtr<ThrowOnError extends boolean = true>(
    options: Options<BucketGetBucketOtrData, ThrowOnError>,
  ) {
    return (options.client ?? _heyApiClient).get<
      BucketGetBucketOtrResponse,
      BucketGetBucketOtrError,
      ThrowOnError
    >({
      url: "/ui/buckets/{bucket_name}/ownership_transfer_request",
      ...options,
    });
  }

  /**
   * Accept a bucket OTR
   * Accept an ownership transfer request for a specific workflow.
   *
   * Permission `bucket:update` required if the current user is the new owner of the workflow,
   * otherwise `bucket:update_any` required.
   */
  public static bucketAcceptBucketOtr<ThrowOnError extends boolean = true>(
    options: Options<BucketAcceptBucketOtrData, ThrowOnError>,
  ) {
    return (options.client ?? _heyApiClient).patch<
      BucketAcceptBucketOtrResponse,
      BucketAcceptBucketOtrError,
      ThrowOnError
    >({
      url: "/ui/buckets/{bucket_name}/ownership_transfer_request",
      ...options,
    });
  }

  /**
   * Create a bucket OTR
   * Create a ownership transfer request for a specific bucket.
   *
   * Permission `bucket:update` required if the current user is the current owner of the bucket,
   * otherwise `bucket:update_any` required.
   */
  public static bucketCreateBucketOtr<ThrowOnError extends boolean = true>(
    options: Options<BucketCreateBucketOtrData, ThrowOnError>,
  ) {
    return (options.client ?? _heyApiClient).post<
      BucketCreateBucketOtrResponse,
      BucketCreateBucketOtrError,
      ThrowOnError
    >({
      url: "/ui/buckets/{bucket_name}/ownership_transfer_request",
      ...options,
      headers: {
        "Content-Type": "application/json",
        ...options?.headers,
      },
    });
  }

  /**
   * Update public status
   * Update the buckets public state.
   *
   * Permission `bucket:update` required if the current user is the owner of the bucket,
   * otherwise `bucket:update_any` required.
   */
  public static bucketUpdateBucketPublicState<
    ThrowOnError extends boolean = true,
  >(options: Options<BucketUpdateBucketPublicStateData, ThrowOnError>) {
    return (options.client ?? _heyApiClient).patch<
      BucketUpdateBucketPublicStateResponse,
      BucketUpdateBucketPublicStateError,
      ThrowOnError
    >({
      url: "/ui/buckets/{bucket_name}/public",
      ...options,
      headers: {
        "Content-Type": "application/json",
        ...options?.headers,
      },
    });
  }

  /**
   * Update bucket limits
   * Update the buckets size limits.
   *
   * Permission `bucket:update_any` required.
   */
  public static bucketUpdateBucketLimits<ThrowOnError extends boolean = true>(
    options: Options<BucketUpdateBucketLimitsData, ThrowOnError>,
  ) {
    return (options.client ?? _heyApiClient).patch<
      BucketUpdateBucketLimitsResponse,
      BucketUpdateBucketLimitsError,
      ThrowOnError
    >({
      url: "/ui/buckets/{bucket_name}/limits",
      ...options,
      headers: {
        "Content-Type": "application/json",
        ...options?.headers,
      },
    });
  }
}

export class BucketPermissionService {
  /**
   * Get all permissions.
   * List all the bucket permissions in the system.
   *
   * Permission `bucket_permission:list_all` required.
   */
  public static bucketPermissionListPermissions<
    ThrowOnError extends boolean = true,
  >(options?: Options<BucketPermissionListPermissionsData, ThrowOnError>) {
    return (options?.client ?? _heyApiClient).get<
      BucketPermissionListPermissionsResponse,
      BucketPermissionListPermissionsError,
      ThrowOnError
    >({
      url: "/ui/permissions",
      ...options,
    });
  }

  /**
   * Create a permission.
   * Create a permission for a bucket and user.
   *
   * Permission `bucket_permission:create` required.
   */
  public static bucketPermissionCreatePermission<
    ThrowOnError extends boolean = true,
  >(options: Options<BucketPermissionCreatePermissionData, ThrowOnError>) {
    return (options.client ?? _heyApiClient).post<
      BucketPermissionCreatePermissionResponse,
      BucketPermissionCreatePermissionError,
      ThrowOnError
    >({
      url: "/ui/permissions",
      ...options,
      headers: {
        "Content-Type": "application/json",
        ...options?.headers,
      },
    });
  }

  /**
   * Get all permissions for a user.
   * List all the bucket permissions for the given user.
   *
   * Permission `bucket_permission:list` required if current user is the target the bucket permission,
   * otherwise `bucket_permission:list_all` required.
   */
  public static bucketPermissionListPermissionsPerUser<
    ThrowOnError extends boolean = true,
  >(
    options: Options<BucketPermissionListPermissionsPerUserData, ThrowOnError>,
  ) {
    return (options.client ?? _heyApiClient).get<
      BucketPermissionListPermissionsPerUserResponse,
      BucketPermissionListPermissionsPerUserError,
      ThrowOnError
    >({
      url: "/ui/permissions/user/{uid}",
      ...options,
    });
  }

  /**
   * Get all permissions for a bucket.
   * List all the bucket permissions for the given bucket.
   *
   * Permission `bucket_permission:list` required if current user is owner of the bucket,
   * otherwise `bucket_permission:list_all` required.
   */
  public static bucketPermissionListPermissionsPerBucket<
    ThrowOnError extends boolean = true,
  >(
    options: Options<
      BucketPermissionListPermissionsPerBucketData,
      ThrowOnError
    >,
  ) {
    return (options.client ?? _heyApiClient).get<
      BucketPermissionListPermissionsPerBucketResponse,
      BucketPermissionListPermissionsPerBucketError,
      ThrowOnError
    >({
      url: "/ui/permissions/bucket/{bucket_name}",
      ...options,
    });
  }

  /**
   * Delete a bucket permission
   * Delete the bucket permissions for the specific combination of bucket and user.
   *
   * Permission `bucket_permission:delete` required if current user is the target or owner of the bucket permission,
   * otherwise `bucket_permission:delete_any` required.
   */
  public static bucketPermissionDeletePermission<
    ThrowOnError extends boolean = true,
  >(options: Options<BucketPermissionDeletePermissionData, ThrowOnError>) {
    return (options.client ?? _heyApiClient).delete<
      BucketPermissionDeletePermissionResponse,
      BucketPermissionDeletePermissionError,
      ThrowOnError
    >({
      url: "/ui/permissions/bucket/{bucket_name}/user/{uid}",
      ...options,
    });
  }

  /**
   * Get permission for bucket and user combination.
   * Get the bucket permissions for the specific combination of bucket and user.
   *
   * Permission `bucket_permission:read` required if current user is the target or owner of the bucket permission,
   * otherwise `bucket_permission:read_any` required.
   */
  public static bucketPermissionGetPermission<
    ThrowOnError extends boolean = true,
  >(options: Options<BucketPermissionGetPermissionData, ThrowOnError>) {
    return (options.client ?? _heyApiClient).get<
      BucketPermissionGetPermissionResponse,
      BucketPermissionGetPermissionError,
      ThrowOnError
    >({
      url: "/ui/permissions/bucket/{bucket_name}/user/{uid}",
      ...options,
    });
  }

  /**
   * Update a bucket permission
   * Update a permission for a bucket and user.
   *
   * Permission `bucket_permission:update` required.
   */
  public static bucketPermissionUpdatePermission<
    ThrowOnError extends boolean = true,
  >(options: Options<BucketPermissionUpdatePermissionData, ThrowOnError>) {
    return (options.client ?? _heyApiClient).put<
      BucketPermissionUpdatePermissionResponse,
      BucketPermissionUpdatePermissionError,
      ThrowOnError
    >({
      url: "/ui/permissions/bucket/{bucket_name}/user/{uid}",
      ...options,
      headers: {
        "Content-Type": "application/json",
        ...options?.headers,
      },
    });
  }
}

export class WorkflowService {
  /**
   * List workflows
   * List all workflows.
   *
   * Permission `workflow:list` required.
   */
  public static workflowListWorkflows<ThrowOnError extends boolean = true>(
    options?: Options<WorkflowListWorkflowsData, ThrowOnError>,
  ) {
    return (options?.client ?? _heyApiClient).get<
      WorkflowListWorkflowsResponse,
      WorkflowListWorkflowsError,
      ThrowOnError
    >({
      url: "/ui/workflows",
      ...options,
    });
  }

  /**
   * Create a new workflow
   * Create a new workflow.
   *
   * For private Gitlab repositories, a Project Access Token with the role Reporter and scope `read_api` is needed.
   *
   * For private GitHub repositories, a Personal Access Token (classic) with scope `repo` is needed.
   *
   * Permission `workflow:create` required.
   */
  public static workflowCreateWorkflow<ThrowOnError extends boolean = true>(
    options: Options<WorkflowCreateWorkflowData, ThrowOnError>,
  ) {
    return (options.client ?? _heyApiClient).post<
      WorkflowCreateWorkflowResponse,
      WorkflowCreateWorkflowError,
      ThrowOnError
    >({
      url: "/ui/workflows",
      ...options,
      headers: {
        "Content-Type": "application/json",
        ...options?.headers,
      },
    });
  }

  /**
   * List workflow OTRs
   * Get the ownership transfer requests for workflows.
   *
   * Permission `workflow:list` required if `current_owner_id` or `new_owner_id` is the current users id,
   * otherwise `workflow:list_all`
   */
  public static workflowListWorkflowOtrs<ThrowOnError extends boolean = true>(
    options?: Options<WorkflowListWorkflowOtrsData, ThrowOnError>,
  ) {
    return (options?.client ?? _heyApiClient).get<
      WorkflowListWorkflowOtrsResponse,
      WorkflowListWorkflowOtrsError,
      ThrowOnError
    >({
      url: "/ui/workflows/ownership_transfer_request",
      ...options,
    });
  }

  /**
   * Get anonymized workflow execution
   * Get the workflow executions with meta information and anonymized user IDs.
   *
   * Permission `workflow:read` required if the `developer_id` is the same as the uid of the current user,
   * other `workflow:read_any`.
   */
  public static workflowGetDeveloperWorkflowStatistics<
    ThrowOnError extends boolean = true,
  >(
    options?: Options<WorkflowGetDeveloperWorkflowStatisticsData, ThrowOnError>,
  ) {
    return (options?.client ?? _heyApiClient).get<
      WorkflowGetDeveloperWorkflowStatisticsResponse,
      WorkflowGetDeveloperWorkflowStatisticsError,
      ThrowOnError
    >({
      url: "/ui/workflows/developer_statistics",
      ...options,
    });
  }

  /**
   * Delete a workflow
   * Delete a workflow.
   *
   * Permission `workflow:delete` required if the `developer_id` is the same as the uid of the current user,
   * other `workflow:delete_any`.
   */
  public static workflowDeleteWorkflow<ThrowOnError extends boolean = true>(
    options: Options<WorkflowDeleteWorkflowData, ThrowOnError>,
  ) {
    return (options.client ?? _heyApiClient).delete<
      WorkflowDeleteWorkflowResponse,
      WorkflowDeleteWorkflowError,
      ThrowOnError
    >({
      url: "/ui/workflows/{wid}",
      ...options,
    });
  }

  /**
   * Get a workflow
   * Get a specific workflow.
   *
   * Permission `workflow:read` required.
   */
  public static workflowGetWorkflow<ThrowOnError extends boolean = true>(
    options: Options<WorkflowGetWorkflowData, ThrowOnError>,
  ) {
    return (options.client ?? _heyApiClient).get<
      WorkflowGetWorkflowResponse,
      WorkflowGetWorkflowError,
      ThrowOnError
    >({
      url: "/ui/workflows/{wid}",
      ...options,
    });
  }

  /**
   * Delete a workflow OTR
   * Delete/Reject a workflow ownership transfer request.
   *
   * Permission `workflow:update` required if current user is the current or new owner of the workflow,
   * otherwise `workflow:update_any` required.
   */
  public static workflowDeleteWorkflowOtr<ThrowOnError extends boolean = true>(
    options: Options<WorkflowDeleteWorkflowOtrData, ThrowOnError>,
  ) {
    return (options.client ?? _heyApiClient).delete<
      WorkflowDeleteWorkflowOtrResponse,
      WorkflowDeleteWorkflowOtrError,
      ThrowOnError
    >({
      url: "/ui/workflows/{wid}/ownership_transfer_request",
      ...options,
    });
  }

  /**
   * Get a workflow OTR
   * Get a specific workflow ownership transfer request.
   *
   * Permission `workflow:read` required if current user is the current or new owner of the workflow,
   * otherwise `workflow:read_any` required.
   */
  public static workflowGetWorkflowOtr<ThrowOnError extends boolean = true>(
    options: Options<WorkflowGetWorkflowOtrData, ThrowOnError>,
  ) {
    return (options.client ?? _heyApiClient).get<
      WorkflowGetWorkflowOtrResponse,
      WorkflowGetWorkflowOtrError,
      ThrowOnError
    >({
      url: "/ui/workflows/{wid}/ownership_transfer_request",
      ...options,
    });
  }

  /**
   * Accept a workflow OTR
   * Accept an ownership transfer request for a specific workflow.
   *
   * Permission `workflow:update` required if the current user is the new owner of the workflow,
   * otherwise `workflow:update_any` required.
   */
  public static workflowAcceptWorkflowOtr<ThrowOnError extends boolean = true>(
    options: Options<WorkflowAcceptWorkflowOtrData, ThrowOnError>,
  ) {
    return (options.client ?? _heyApiClient).patch<
      WorkflowAcceptWorkflowOtrResponse,
      WorkflowAcceptWorkflowOtrError,
      ThrowOnError
    >({
      url: "/ui/workflows/{wid}/ownership_transfer_request",
      ...options,
    });
  }

  /**
   * Create a workflow OTR
   * Create a ownership transfer request for a specific workflow.
   *
   * Permission `workflow:update` required if the current user is the current owner of the workflow,
   * otherwise `workflow:update_any` required.
   */
  public static workflowCreateWorkflowOtr<ThrowOnError extends boolean = true>(
    options: Options<WorkflowCreateWorkflowOtrData, ThrowOnError>,
  ) {
    return (options.client ?? _heyApiClient).post<
      WorkflowCreateWorkflowOtrResponse,
      WorkflowCreateWorkflowOtrError,
      ThrowOnError
    >({
      url: "/ui/workflows/{wid}/ownership_transfer_request",
      ...options,
      headers: {
        "Content-Type": "application/json",
        ...options?.headers,
      },
    });
  }

  /**
   * Get statistics for a workflow
   * Get the number of started workflow per day.
   *
   * Permission `workflow:read` required.
   */
  public static workflowGetWorkflowStatistics<
    ThrowOnError extends boolean = true,
  >(options: Options<WorkflowGetWorkflowStatisticsData, ThrowOnError>) {
    return (options.client ?? _heyApiClient).get<
      WorkflowGetWorkflowStatisticsResponse,
      WorkflowGetWorkflowStatisticsError,
      ThrowOnError
    >({
      url: "/ui/workflows/{wid}/statistics",
      ...options,
    });
  }

  /**
   * Update a workflow
   * Create a new workflow version.
   *
   * Permission `workflow:update` required.
   */
  public static workflowUpdateWorkflow<ThrowOnError extends boolean = true>(
    options: Options<WorkflowUpdateWorkflowData, ThrowOnError>,
  ) {
    return (options.client ?? _heyApiClient).post<
      WorkflowUpdateWorkflowResponse,
      WorkflowUpdateWorkflowError,
      ThrowOnError
    >({
      url: "/ui/workflows/{wid}/update",
      ...options,
      headers: {
        "Content-Type": "application/json",
        ...options?.headers,
      },
    });
  }
}

export class WorkflowVersionService {
  /**
   * Get all versions of a workflow
   * List all versions of a Workflow.
   *
   * Permission `workflow:list` required.
   */
  public static workflowVersionListWorkflowVersion<
    ThrowOnError extends boolean = true,
  >(options: Options<WorkflowVersionListWorkflowVersionData, ThrowOnError>) {
    return (options.client ?? _heyApiClient).get<
      WorkflowVersionListWorkflowVersionResponse,
      WorkflowVersionListWorkflowVersionError,
      ThrowOnError
    >({
      url: "/ui/workflows/{wid}/versions",
      ...options,
    });
  }

  /**
   * Get a workflow version
   * Get a specific version of a workflow.
   *
   * Permission `workflow:read` required if the version is public or you are the developer of the workflow,
   * otherwise `workflow:read_any`
   */
  public static workflowVersionGetWorkflowVersion<
    ThrowOnError extends boolean = true,
  >(options: Options<WorkflowVersionGetWorkflowVersionData, ThrowOnError>) {
    return (options.client ?? _heyApiClient).get<
      WorkflowVersionGetWorkflowVersionResponse,
      WorkflowVersionGetWorkflowVersionError,
      ThrowOnError
    >({
      url: "/ui/workflows/{wid}/versions/{git_commit_hash}",
      ...options,
    });
  }

  /**
   * Update status of workflow version
   * Update the status of a workflow version.
   *
   * Permission `workflow:update_status`
   */
  public static workflowVersionUpdateWorkflowVersionStatus<
    ThrowOnError extends boolean = true,
  >(
    options: Options<
      WorkflowVersionUpdateWorkflowVersionStatusData,
      ThrowOnError
    >,
  ) {
    return (options.client ?? _heyApiClient).patch<
      WorkflowVersionUpdateWorkflowVersionStatusResponse,
      WorkflowVersionUpdateWorkflowVersionStatusError,
      ThrowOnError
    >({
      url: "/ui/workflows/{wid}/versions/{git_commit_hash}/status",
      ...options,
      headers: {
        "Content-Type": "application/json",
        ...options?.headers,
      },
    });
  }

  /**
   * Get metadata of workflow version
   * Get the metadata of a workflow version.
   *
   * Permission `workflow:read` required if the current user is the developer of the workflow,
   * otherwise `workflow:read_any`
   */
  public static workflowVersionGetWorkflowVersionMetadata<
    ThrowOnError extends boolean = true,
  >(
    options: Options<
      WorkflowVersionGetWorkflowVersionMetadataData,
      ThrowOnError
    >,
  ) {
    return (options.client ?? _heyApiClient).get<
      WorkflowVersionGetWorkflowVersionMetadataResponse,
      WorkflowVersionGetWorkflowVersionMetadataError,
      ThrowOnError
    >({
      url: "/ui/workflows/{wid}/versions/{git_commit_hash}/metadata",
      ...options,
    });
  }

  /**
   * Update metadata of workflow version
   * Update the metadata of a workflow version.
   *
   * Permission `workflow:update` required if the current user is the developer of the workflow,
   * otherwise `workflow:update_any`
   */
  public static workflowVersionUpdateWorkflowVersionMetadata<
    ThrowOnError extends boolean = true,
  >(
    options: Options<
      WorkflowVersionUpdateWorkflowVersionMetadataData,
      ThrowOnError
    >,
  ) {
    return (options.client ?? _heyApiClient).put<
      WorkflowVersionUpdateWorkflowVersionMetadataResponse,
      WorkflowVersionUpdateWorkflowVersionMetadataError,
      ThrowOnError
    >({
      url: "/ui/workflows/{wid}/versions/{git_commit_hash}/metadata",
      ...options,
      headers: {
        "Content-Type": "application/json",
        ...options?.headers,
      },
    });
  }

  /**
   * Deprecate a workflow version
   * Deprecate a workflow version.
   *
   * Permission `workflow:update` required if you are the developer of the workflow,
   * otherwise `workflow:update_status`
   */
  public static workflowVersionDeprecateWorkflowVersion<
    ThrowOnError extends boolean = true,
  >(
    options: Options<WorkflowVersionDeprecateWorkflowVersionData, ThrowOnError>,
  ) {
    return (options.client ?? _heyApiClient).patch<
      WorkflowVersionDeprecateWorkflowVersionResponse,
      WorkflowVersionDeprecateWorkflowVersionError,
      ThrowOnError
    >({
      url: "/ui/workflows/{wid}/versions/{git_commit_hash}/deprecate",
      ...options,
    });
  }

  /**
   * Update parameter extension of workflow version
   * Update the parameter extension of a workflow version.
   *
   * Permission `workflow:update` required.
   */
  public static workflowVersionUpdateWorkflowVersionParameterExtension<
    ThrowOnError extends boolean = true,
  >(
    options: Options<
      WorkflowVersionUpdateWorkflowVersionParameterExtensionData,
      ThrowOnError
    >,
  ) {
    return (options.client ?? _heyApiClient).patch<
      WorkflowVersionUpdateWorkflowVersionParameterExtensionResponse,
      WorkflowVersionUpdateWorkflowVersionParameterExtensionError,
      ThrowOnError
    >({
      url: "/ui/workflows/{wid}/versions/{git_commit_hash}/parameter-extension",
      ...options,
      headers: {
        "Content-Type": "application/json",
        ...options?.headers,
      },
    });
  }

  /**
   * Fetch documentation for a workflow version
   * Get the documentation for a specific workflow version.
   * Streams the response directly from the right git repository.
   *
   * Permission `workflow:read` required.
   */
  public static workflowVersionDownloadWorkflowDocumentation<
    ThrowOnError extends boolean = true,
  >(
    options: Options<
      WorkflowVersionDownloadWorkflowDocumentationData,
      ThrowOnError
    >,
  ) {
    return (options.client ?? _heyApiClient).get<
      unknown,
      WorkflowVersionDownloadWorkflowDocumentationError,
      ThrowOnError
    >({
      url: "/ui/workflows/{wid}/versions/{git_commit_hash}/documentation",
      ...options,
    });
  }

  /**
   * Delete icon of workflow version
   * Delete the icon of the workflow version.
   *
   * Permission `workflow:update` required.
   */
  public static workflowVersionDeleteWorkflowVersionIcon<
    ThrowOnError extends boolean = true,
  >(
    options: Options<
      WorkflowVersionDeleteWorkflowVersionIconData,
      ThrowOnError
    >,
  ) {
    return (options.client ?? _heyApiClient).delete<
      WorkflowVersionDeleteWorkflowVersionIconResponse,
      WorkflowVersionDeleteWorkflowVersionIconError,
      ThrowOnError
    >({
      url: "/ui/workflows/{wid}/versions/{git_commit_hash}/icon",
      ...options,
    });
  }

  /**
   * Upload icon for workflow version
   * Upload an icon for the workflow version and returns the new icon URL.
   *
   * Permission `workflow:update` required.
   */
  public static workflowVersionUploadWorkflowVersionIcon<
    ThrowOnError extends boolean = true,
  >(
    options: Options<
      WorkflowVersionUploadWorkflowVersionIconData,
      ThrowOnError
    >,
  ) {
    return (options.client ?? _heyApiClient).post<
      WorkflowVersionUploadWorkflowVersionIconResponse,
      WorkflowVersionUploadWorkflowVersionIconError,
      ThrowOnError
    >({
      ...formDataBodySerializer,
      url: "/ui/workflows/{wid}/versions/{git_commit_hash}/icon",
      ...options,
      headers: {
        "Content-Type": null,
        ...options?.headers,
      },
    });
  }
}

export class WorkflowExecutionService {
  /**
   * List all workflow executions
   * Get all workflow executions.
   *
   * This endpoint enforces keyset pagination. To iterate over all workflow executions, follow the link provided in the
   * `Link` header.
   * A missing `Link` header indicates that you iterated over all workflow executions with the current filters.
   *
   * Permission `workflow_execution:list` required, if `executor_id` is the same as the current user,
   * otherwise `workflow_execution:list_all` required.
   */
  public static workflowExecutionListWorkflowExecutions<
    ThrowOnError extends boolean = true,
  >(
    options?: Options<
      WorkflowExecutionListWorkflowExecutionsData,
      ThrowOnError
    >,
  ) {
    return (options?.client ?? _heyApiClient).get<
      WorkflowExecutionListWorkflowExecutionsResponse,
      WorkflowExecutionListWorkflowExecutionsError,
      ThrowOnError
    >({
      url: "/ui/workflow_executions",
      ...options,
    });
  }

  /**
   * Start a new workflow execution
   * Start a new workflow execution. Workflow versions wit status `DEPRECATED` or `DENIED` can't be started.
   *
   * Permission `workflow_execution:create` required if workflow versions status is `PUBLISHED`,
   * otherwise `workflow_execution:create_any` required.
   */
  public static workflowExecutionStartWorkflow<
    ThrowOnError extends boolean = true,
  >(options: Options<WorkflowExecutionStartWorkflowData, ThrowOnError>) {
    return (options.client ?? _heyApiClient).post<
      WorkflowExecutionStartWorkflowResponse,
      WorkflowExecutionStartWorkflowError,
      ThrowOnError
    >({
      url: "/ui/workflow_executions",
      ...options,
      headers: {
        "Content-Type": "application/json",
        ...options?.headers,
      },
    });
  }

  /**
   * Start a workflow execution with arbitrary git repository
   * Start a new workflow execution from an arbitrary git repository.
   *
   * For private Gitlab repositories, a Project Access Token with the role Reporter and scope `read_api` is needed.
   *
   * For private GitHub repositories, a Personal Access Token (classic) with scope `repo` is needed.
   *
   * Permission `workflow:create` required.
   */
  public static workflowExecutionStartArbitraryWorkflow<
    ThrowOnError extends boolean = true,
  >(
    options: Options<WorkflowExecutionStartArbitraryWorkflowData, ThrowOnError>,
  ) {
    return (options.client ?? _heyApiClient).post<
      WorkflowExecutionStartArbitraryWorkflowResponse,
      WorkflowExecutionStartArbitraryWorkflowError,
      ThrowOnError
    >({
      url: "/ui/workflow_executions/arbitrary",
      ...options,
      headers: {
        "Content-Type": "application/json",
        ...options?.headers,
      },
    });
  }

  /**
   * Delete a workflow execution
   * Delete a specific workflow execution.
   *
   * Permission `workflow_execution:delete` required if the current user started the workflow execution,
   * otherwise `workflow_execution:delete_any` required.
   */
  public static workflowExecutionDeleteWorkflowExecution<
    ThrowOnError extends boolean = true,
  >(
    options: Options<
      WorkflowExecutionDeleteWorkflowExecutionData,
      ThrowOnError
    >,
  ) {
    return (options.client ?? _heyApiClient).delete<
      WorkflowExecutionDeleteWorkflowExecutionResponse,
      WorkflowExecutionDeleteWorkflowExecutionError,
      ThrowOnError
    >({
      url: "/ui/workflow_executions/{eid}",
      ...options,
    });
  }

  /**
   * Get a workflow execution
   * Get a specific workflow execution.
   *
   * Permission `workflow_execution:read` required if the current user started the workflow execution,
   * otherwise `workflow_execution:read_any` required.
   */
  public static workflowExecutionGetWorkflowExecution<
    ThrowOnError extends boolean = true,
  >(options: Options<WorkflowExecutionGetWorkflowExecutionData, ThrowOnError>) {
    return (options.client ?? _heyApiClient).get<
      WorkflowExecutionGetWorkflowExecutionResponse,
      WorkflowExecutionGetWorkflowExecutionError,
      ThrowOnError
    >({
      url: "/ui/workflow_executions/{eid}",
      ...options,
    });
  }

  /**
   * Get the parameters of a workflow execution
   * Get the parameters of a specific workflow execution.
   *
   * Permission `workflow_execution:read` required if the current user started the workflow execution,
   * otherwise `workflow_execution:read_any` required.
   */
  public static workflowExecutionGetWorkflowExecutionParams<
    ThrowOnError extends boolean = true,
  >(
    options: Options<
      WorkflowExecutionGetWorkflowExecutionParamsData,
      ThrowOnError
    >,
  ) {
    return (options.client ?? _heyApiClient).get<
      WorkflowExecutionGetWorkflowExecutionParamsResponse,
      WorkflowExecutionGetWorkflowExecutionParamsError,
      ThrowOnError
    >({
      url: "/ui/workflow_executions/{eid}/params",
      ...options,
    });
  }

  /**
   * Cancel a workflow execution
   * Cancel a running workflow execution.
   *
   * Permission `workflow_execution:cancel` required if the current user started the workflow execution,
   * otherwise `workflow_execution:cancel_any` required.
   */
  public static workflowExecutionCancelWorkflowExecution<
    ThrowOnError extends boolean = true,
  >(
    options: Options<
      WorkflowExecutionCancelWorkflowExecutionData,
      ThrowOnError
    >,
  ) {
    return (options.client ?? _heyApiClient).post<
      WorkflowExecutionCancelWorkflowExecutionResponse,
      WorkflowExecutionCancelWorkflowExecutionError,
      ThrowOnError
    >({
      url: "/ui/workflow_executions/{eid}/cancel",
      ...options,
    });
  }
}

export class WorkflowCredentialsService {
  /**
   * Delete the credentials of a workflow
   * Delete the credentials for the repository of a workflow.
   *
   * Permission `workflow:delete` required if the developer of the workflow is the same as the current user,
   * other `workflow:delete_any`.
   */
  public static workflowCredentialsDeleteWorkflowCredentials<
    ThrowOnError extends boolean = true,
  >(
    options: Options<
      WorkflowCredentialsDeleteWorkflowCredentialsData,
      ThrowOnError
    >,
  ) {
    return (options.client ?? _heyApiClient).delete<
      WorkflowCredentialsDeleteWorkflowCredentialsResponse,
      WorkflowCredentialsDeleteWorkflowCredentialsError,
      ThrowOnError
    >({
      url: "/ui/workflows/{wid}/credentials",
      ...options,
    });
  }

  /**
   * Get the credentials of a workflow
   * Get the credentials for the repository of a workflow. Only the developer of a workflow can do this.
   *
   * Permission `workflow:update` required.
   */
  public static workflowCredentialsGetWorkflowCredentials<
    ThrowOnError extends boolean = true,
  >(
    options: Options<
      WorkflowCredentialsGetWorkflowCredentialsData,
      ThrowOnError
    >,
  ) {
    return (options.client ?? _heyApiClient).get<
      WorkflowCredentialsGetWorkflowCredentialsResponse,
      WorkflowCredentialsGetWorkflowCredentialsError,
      ThrowOnError
    >({
      url: "/ui/workflows/{wid}/credentials",
      ...options,
    });
  }

  /**
   * Update the credentials of a workflow
   * Update the credentials for the repository of a workflow.
   *
   * Permission `workflow:update` required.
   */
  public static workflowCredentialsUpdateWorkflowCredentials<
    ThrowOnError extends boolean = true,
  >(
    options: Options<
      WorkflowCredentialsUpdateWorkflowCredentialsData,
      ThrowOnError
    >,
  ) {
    return (options.client ?? _heyApiClient).put<
      unknown,
      WorkflowCredentialsUpdateWorkflowCredentialsError,
      ThrowOnError
    >({
      url: "/ui/workflows/{wid}/credentials",
      ...options,
      headers: {
        "Content-Type": "application/json",
        ...options?.headers,
      },
    });
  }
}

export class WorkflowModeService {
  /**
   * Get workflow mode
   * Get a workflow mode.
   *
   * Permission `workflow:read` required
   */
  public static workflowModeGetWorkflowMode<
    ThrowOnError extends boolean = true,
  >(options: Options<WorkflowModeGetWorkflowModeData, ThrowOnError>) {
    return (options.client ?? _heyApiClient).get<
      WorkflowModeGetWorkflowModeResponse,
      WorkflowModeGetWorkflowModeError,
      ThrowOnError
    >({
      url: "/ui/workflow_modes/{mode_id}",
      ...options,
    });
  }
}

export class ResourceService {
  /**
   * List resources
   * List all resources.
   *
   * Permission `resource:list` required.
   */
  public static resourceListResources<ThrowOnError extends boolean = true>(
    options?: Options<ResourceListResourcesData, ThrowOnError>,
  ) {
    return (options?.client ?? _heyApiClient).get<
      ResourceListResourcesResponse,
      ResourceListResourcesError,
      ThrowOnError
    >({
      url: "/ui/resources",
      ...options,
    });
  }

  /**
   * Request a new resource
   * Request a new resources.
   *
   * Permission `resource:create` required.
   */
  public static resourceCreateResource<ThrowOnError extends boolean = true>(
    options: Options<ResourceCreateResourceData, ThrowOnError>,
  ) {
    return (options.client ?? _heyApiClient).post<
      ResourceCreateResourceResponse,
      ResourceCreateResourceError,
      ThrowOnError
    >({
      url: "/ui/resources",
      ...options,
      headers: {
        "Content-Type": "application/json",
        ...options?.headers,
      },
    });
  }

  /**
   * List resource sync requests
   * List all resource sync requests.
   *
   * Permission `resource:update_any` required.
   */
  public static resourceListSyncRequests<ThrowOnError extends boolean = true>(
    options?: Options<ResourceListSyncRequestsData, ThrowOnError>,
  ) {
    return (options?.client ?? _heyApiClient).get<
      ResourceListSyncRequestsResponse,
      unknown,
      ThrowOnError
    >({
      url: "/ui/resources/sync_requests",
      ...options,
    });
  }

  /**
   * List resource OTRs
   * Get the ownership transfer requests for resources.
   *
   * Permission `resource:list` required if `current_owner_id` or `new_owner_id` is the current users id,
   * otherwise `resource:list_all`
   */
  public static resourceListResourceOtrs<ThrowOnError extends boolean = true>(
    options?: Options<ResourceListResourceOtrsData, ThrowOnError>,
  ) {
    return (options?.client ?? _heyApiClient).get<
      ResourceListResourceOtrsResponse,
      ResourceListResourceOtrsError,
      ThrowOnError
    >({
      url: "/ui/resources/ownership_transfer_request",
      ...options,
    });
  }

  /**
   * Delete a resource
   * Delete a resources.
   *
   * Permission `resource:delete` required.
   */
  public static resourceDeleteResource<ThrowOnError extends boolean = true>(
    options: Options<ResourceDeleteResourceData, ThrowOnError>,
  ) {
    return (options.client ?? _heyApiClient).delete<
      ResourceDeleteResourceResponse,
      ResourceDeleteResourceError,
      ThrowOnError
    >({
      url: "/ui/resources/{rid}",
      ...options,
    });
  }

  /**
   * Get a resource
   * Get a specific resource.
   *
   * Permission `resource:read` required.
   */
  public static resourceGetResource<ThrowOnError extends boolean = true>(
    options: Options<ResourceGetResourceData, ThrowOnError>,
  ) {
    return (options.client ?? _heyApiClient).get<
      ResourceGetResourceResponse,
      ResourceGetResourceError,
      ThrowOnError
    >({
      url: "/ui/resources/{rid}",
      ...options,
    });
  }

  /**
   * Delete a resource OTR
   * Delete/Reject a resource ownership transfer request.
   *
   * Permission `resource:update` required if the current user is the current or new owner of the resource,
   * otherwise `resource:update_any` required.
   */
  public static resourceDeleteResourceOtr<ThrowOnError extends boolean = true>(
    options: Options<ResourceDeleteResourceOtrData, ThrowOnError>,
  ) {
    return (options.client ?? _heyApiClient).delete<
      ResourceDeleteResourceOtrResponse,
      ResourceDeleteResourceOtrError,
      ThrowOnError
    >({
      url: "/ui/resources/{rid}/ownership_transfer_request",
      ...options,
    });
  }

  /**
   * Get a resource OTR
   * Get a specific resource ownership transfer request.
   *
   * Permission `resource:read` required if the current user is the current or new owner of the resource,
   * otherwise `resource:read_any` required.
   */
  public static resourceGetResourceOtr<ThrowOnError extends boolean = true>(
    options: Options<ResourceGetResourceOtrData, ThrowOnError>,
  ) {
    return (options.client ?? _heyApiClient).get<
      ResourceGetResourceOtrResponse,
      ResourceGetResourceOtrError,
      ThrowOnError
    >({
      url: "/ui/resources/{rid}/ownership_transfer_request",
      ...options,
    });
  }

  /**
   * Accept a resource OTR
   * Accept an ownership transfer request for a specific resource.
   *
   * Permission `resource:update` required if the current user is the new owner of the resource,
   * otherwise `resource:update_any` required.
   */
  public static resourceAcceptResourceOtr<ThrowOnError extends boolean = true>(
    options: Options<ResourceAcceptResourceOtrData, ThrowOnError>,
  ) {
    return (options.client ?? _heyApiClient).patch<
      ResourceAcceptResourceOtrResponse,
      ResourceAcceptResourceOtrError,
      ThrowOnError
    >({
      url: "/ui/resources/{rid}/ownership_transfer_request",
      ...options,
    });
  }

  /**
   * Create a resource OTR
   * Create a ownership transfer request for a specific resource.
   *
   * Permission `resource:update` required if the current user is the current owner of the resource,
   * otherwise `resource:update_any` required.
   */
  public static resourceCreateResourceOtr<ThrowOnError extends boolean = true>(
    options: Options<ResourceCreateResourceOtrData, ThrowOnError>,
  ) {
    return (options.client ?? _heyApiClient).post<
      ResourceCreateResourceOtrResponse,
      ResourceCreateResourceOtrError,
      ThrowOnError
    >({
      url: "/ui/resources/{rid}/ownership_transfer_request",
      ...options,
      headers: {
        "Content-Type": "application/json",
        ...options?.headers,
      },
    });
  }
}

export class ResourceVersionService {
  /**
   * List versions of a resource
   * List all the resource version for a specific resource.
   *
   * Permission 'resource:read' required.
   */
  public static resourceVersionListResourceVersions<
    ThrowOnError extends boolean = true,
  >(options: Options<ResourceVersionListResourceVersionsData, ThrowOnError>) {
    return (options.client ?? _heyApiClient).get<
      ResourceVersionListResourceVersionsResponse,
      ResourceVersionListResourceVersionsError,
      ThrowOnError
    >({
      url: "/ui/resources/{rid}/versions",
      ...options,
    });
  }

  /**
   * Request new version of a resource
   * Request a new resource version.
   *
   * Permission `resource:update` required if the current user is the maintainer, `resource:update_any` otherwise.
   */
  public static resourceVersionRequestResourceVersion<
    ThrowOnError extends boolean = true,
  >(options: Options<ResourceVersionRequestResourceVersionData, ThrowOnError>) {
    return (options.client ?? _heyApiClient).post<
      ResourceVersionRequestResourceVersionResponse,
      ResourceVersionRequestResourceVersionError,
      ThrowOnError
    >({
      url: "/ui/resources/{rid}/versions",
      ...options,
      headers: {
        "Content-Type": "application/json",
        ...options?.headers,
      },
    });
  }

  /**
   * Get version of a resource
   * Get a specific resource version for a specific resource.
   *
   * Permission `resource:read` required. If the status of the resource version is not `LATEST` or `SYNCHRONIZED` and
   * the current user is not the maintainer, then the permission `resource:read_any` is required.
   */
  public static resourceVersionGetResourceVersion<
    ThrowOnError extends boolean = true,
  >(options: Options<ResourceVersionGetResourceVersionData, ThrowOnError>) {
    return (options.client ?? _heyApiClient).get<
      ResourceVersionGetResourceVersionResponse,
      ResourceVersionGetResourceVersionError,
      ThrowOnError
    >({
      url: "/ui/resources/{rid}/versions/{rvid}",
      ...options,
    });
  }

  /**
   * Download folder structure of resource
   * Get the folder structure of the resources. Only available if the resource was previously downloaded to the cluster.
   *
   * Permission `resource:read` required.
   */
  public static resourceVersionResourceFileTree<
    ThrowOnError extends boolean = true,
  >(options: Options<ResourceVersionResourceFileTreeData, ThrowOnError>) {
    return (options.client ?? _heyApiClient).get<
      ResourceVersionResourceFileTreeResponse,
      ResourceVersionResourceFileTreeError,
      ThrowOnError
    >({
      responseTransformer: resourceVersionResourceFileTreeResponseTransformer,
      url: "/ui/resources/{rid}/versions/{rvid}/tree",
      ...options,
    });
  }

  /**
   * Request resource version review
   * Request the review of a resource version.
   *
   * Permission `resource:update` required.
   */
  public static resourceVersionRequestResourceVersionReview<
    ThrowOnError extends boolean = true,
  >(
    options: Options<
      ResourceVersionRequestResourceVersionReviewData,
      ThrowOnError
    >,
  ) {
    return (options.client ?? _heyApiClient).put<
      ResourceVersionRequestResourceVersionReviewResponse,
      ResourceVersionRequestResourceVersionReviewError,
      ThrowOnError
    >({
      url: "/ui/resources/{rid}/versions/{rvid}/request_review",
      ...options,
    });
  }

  /**
   * Request resource version synchronization
   * Request the synchronization of a resource version to the cluster.
   *
   * Permission `resource:request_sync` required.
   */
  public static resourceVersionRequestResourceVersionSync<
    ThrowOnError extends boolean = true,
  >(
    options: Options<
      ResourceVersionRequestResourceVersionSyncData,
      ThrowOnError
    >,
  ) {
    return (options.client ?? _heyApiClient).put<
      ResourceVersionRequestResourceVersionSyncResponse,
      ResourceVersionRequestResourceVersionSyncError,
      ThrowOnError
    >({
      url: "/ui/resources/{rid}/versions/{rvid}/request_sync",
      ...options,
      headers: {
        "Content-Type": "application/json",
        ...options?.headers,
      },
    });
  }

  /**
   * Review resource version
   * Review answer the resource version.
   *
   * Permission `resource:update_status` required.
   */
  public static resourceVersionResourceVersionReview<
    ThrowOnError extends boolean = true,
  >(options: Options<ResourceVersionResourceVersionReviewData, ThrowOnError>) {
    return (options.client ?? _heyApiClient).put<
      ResourceVersionResourceVersionReviewResponse,
      ResourceVersionResourceVersionReviewError,
      ThrowOnError
    >({
      url: "/ui/resources/{rid}/versions/{rvid}/review",
      ...options,
      headers: {
        "Content-Type": "application/json",
        ...options?.headers,
      },
    });
  }

  /**
   * Synchronize resource version with cluster
   * Synchronize the resource version to the cluster.
   *
   * Permission `resource:update_any` required.
   */
  public static resourceVersionResourceVersionSync<
    ThrowOnError extends boolean = true,
  >(options: Options<ResourceVersionResourceVersionSyncData, ThrowOnError>) {
    return (options.client ?? _heyApiClient).put<
      ResourceVersionResourceVersionSyncResponse,
      ResourceVersionResourceVersionSyncError,
      ThrowOnError
    >({
      url: "/ui/resources/{rid}/versions/{rvid}/sync",
      ...options,
      headers: {
        "Content-Type": "application/json",
        ...options?.headers,
      },
    });
  }

  /**
   * Set resource version to latest
   * Set the resource version as the latest version.
   *
   * Permission `resource:update_any` required.
   */
  public static resourceVersionResourceVersionLatest<
    ThrowOnError extends boolean = true,
  >(options: Options<ResourceVersionResourceVersionLatestData, ThrowOnError>) {
    return (options.client ?? _heyApiClient).put<
      ResourceVersionResourceVersionLatestResponse,
      ResourceVersionResourceVersionLatestError,
      ThrowOnError
    >({
      url: "/ui/resources/{rid}/versions/{rvid}/latest",
      ...options,
    });
  }

  /**
   * Delete resource version on cluster
   * Delete the resource version on the cluster.
   *
   * Permission `resource:delete_any` required.
   */
  public static resourceVersionDeleteResourceVersionCluster<
    ThrowOnError extends boolean = true,
  >(
    options: Options<
      ResourceVersionDeleteResourceVersionClusterData,
      ThrowOnError
    >,
  ) {
    return (options.client ?? _heyApiClient).delete<
      ResourceVersionDeleteResourceVersionClusterResponse,
      ResourceVersionDeleteResourceVersionClusterError,
      ThrowOnError
    >({
      url: "/ui/resources/{rid}/versions/{rvid}/cluster",
      ...options,
    });
  }

  /**
   * Delete resource version in S3
   * Delete the resource version in the S3 bucket.
   *
   * Permission `resource:delete_any` required.
   */
  public static resourceVersionDeleteResourceVersionS3<
    ThrowOnError extends boolean = true,
  >(
    options: Options<ResourceVersionDeleteResourceVersionS3Data, ThrowOnError>,
  ) {
    return (options.client ?? _heyApiClient).delete<
      ResourceVersionDeleteResourceVersionS3Response,
      ResourceVersionDeleteResourceVersionS3Error,
      ThrowOnError
    >({
      url: "/ui/resources/{rid}/versions/{rvid}/s3",
      ...options,
    });
  }
}

export class NewsService {
  /**
   * List news
   * List all news events with filters.
   *
   * This endpoint enforces keyset pagination. To iterate over all news, follow the link provided in the `Link` header.
   * A missing `Link` header indicates that you iterated over all news with the current filters.
   *
   * Permission `news:list` required.
   */
  public static newsListNews<ThrowOnError extends boolean = true>(
    options?: Options<NewsListNewsData, ThrowOnError>,
  ) {
    return (options?.client ?? _heyApiClient).get<
      NewsListNewsResponse,
      NewsListNewsError,
      ThrowOnError
    >({
      url: "/ui/news",
      ...options,
    });
  }

  /**
   * Create news
   * Create a news event.
   *
   * Permission `news:create` required.
   */
  public static newsCreateNews<ThrowOnError extends boolean = true>(
    options: Options<NewsCreateNewsData, ThrowOnError>,
  ) {
    return (options.client ?? _heyApiClient).post<
      NewsCreateNewsResponse,
      NewsCreateNewsError,
      ThrowOnError
    >({
      url: "/ui/news",
      ...options,
      headers: {
        "Content-Type": "application/json",
        ...options?.headers,
      },
    });
  }

  /**
   * Get latest news
   * List the current news events.
   *
   * Permission `news:list` required.
   */
  public static newsListLatestNews<ThrowOnError extends boolean = true>(
    options?: Options<NewsListLatestNewsData, ThrowOnError>,
  ) {
    return (options?.client ?? _heyApiClient).get<
      NewsListLatestNewsResponse,
      unknown,
      ThrowOnError
    >({
      url: "/ui/news/latest",
      ...options,
    });
  }

  /**
   * Delete a specific news
   * Delete a specified news event.
   *
   * Permission `news:delete` required.
   */
  public static newsDeleteNews<ThrowOnError extends boolean = true>(
    options: Options<NewsDeleteNewsData, ThrowOnError>,
  ) {
    return (options.client ?? _heyApiClient).delete<
      NewsDeleteNewsResponse,
      NewsDeleteNewsError,
      ThrowOnError
    >({
      url: "/ui/news/{nid}",
      ...options,
    });
  }

  /**
   * Get a specific news
   * Get a specified news event.
   *
   * Permission `news:read` required.
   */
  public static newsGetNews<ThrowOnError extends boolean = true>(
    options: Options<NewsGetNewsData, ThrowOnError>,
  ) {
    return (options.client ?? _heyApiClient).get<
      NewsGetNewsResponse,
      NewsGetNewsError,
      ThrowOnError
    >({
      url: "/ui/news/{nid}",
      ...options,
    });
  }
}

export class PublicService {
  /**
   * Get available workflows
   * Public route to fetch all available workflows.
   */
  public static publicGetPublicWorkflows<ThrowOnError extends boolean = true>(
    options?: Options<PublicGetPublicWorkflowsData, ThrowOnError>,
  ) {
    return (options?.client ?? _heyApiClient).get<
      PublicGetPublicWorkflowsResponse,
      unknown,
      ThrowOnError
    >({
      url: "/ui/public/workflows",
      ...options,
    });
  }
}
